SystemOrganization addCategory: #'Xpf-Multipoint-Plugin'!

Object subclass: #MultiPointer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Plugin'!

!MultiPointer class methodsFor: 'as yet unclassified' stamp: 'SR 4/22/2009 14:30'!
getPointerCount

	<primitive: 'primitiveMultiPointerCount' module: 'MultiPointerPlugin'>
	^ 42! !

!MultiPointer class methodsFor: 'as yet unclassified' stamp: 'SR 4/22/2009 14:32'!
getPointerCurrentX: aPointerID

	<primitive: 'primitiveMultiPointerGetCurrentX' module: 'MultiPointerPlugin'>
	^ 42! !

!MultiPointer class methodsFor: 'as yet unclassified' stamp: 'SR 4/22/2009 14:32'!
getPointerCurrentY: aPointerID

	<primitive: 'primitiveMultiPointerGetCurrentY' module: 'MultiPointerPlugin'>
	^ 42! !

!MultiPointer class methodsFor: 'as yet unclassified' stamp: 'SR 4/22/2009 14:31'!
getPointerName: aPointerID

	<primitive: 'primitiveMultiPointerName' module: 'MultiPointerPlugin'>
	^ 'Pointing Device'! !

SmartSyntaxInterpreterPlugin subclass: #MultiPointerPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Plugin'!

!MultiPointerPlugin class methodsFor: 'translation' stamp: 'SR 4/22/2009 14:07'!
hasHeaderFile
	"If there is a single intrinsic header file to be associated with the plugin, here is where you want to flag"
	^ true! !

!MultiPointerPlugin class methodsFor: 'translation' stamp: 'SR 4/22/2009 14:08'!
requiresPlatformFiles
	"this plugin requires platform specific files in order to work"
	^ true! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'SR 4/22/2009 14:28'!
initialiseModule
	"Initialise the module"
	self export: true.
	^self cCode: 'multiPointerInit()' inSmalltalk:[true]! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'SR 4/22/2009 13:23'!
moduleUnloaded: aModuleName 
	"The module with the given name was just unloaded. 
	Make sure we have no dangling references."
	self export: true.! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/22/2009 14:28'!
primitiveMultiPointerCount

	| r |
	self primitive: 'primitiveMultiPointerCount'.
	r := self cCode:' multiPointerCount()'.
	^r asOop: SmallInteger! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/22/2009 14:27'!
primitiveMultiPointerGetCurrentX: aPointerID

	| r |
	self primitive: 'primitiveMultiPointerGetCurrentX' parameters: #(#SmallInteger).
	r := self cCode:' multiPointerGetCurrentX(aPointerID)'.
	^r asOop: SmallInteger! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/22/2009 14:27'!
primitiveMultiPointerGetCurrentY: aPointerID

	| r |
	self primitive: 'primitiveMultiPointerGetCurrentY' parameters: #(#SmallInteger).
	r := self cCode:' multiPointerGetCurrentY(aPointerID)'.
	^r asOop: SmallInteger! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/22/2009 15:16'!
primitiveMultiPointerName: aPointerID

	| oop length |
	self primitive:'primitiveMultiPointerName'.
	length := self multiPointerNameLenght: aPointerID.
	oop := interpreterProxy instantiateClass: interpreterProxy classString indexableSize: length.
	self multiPointerName: (interpreterProxy firstIndexableField: oop).
	^oop! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'SR 4/22/2009 14:28'!
shutdownModule
	"Initialise the module"
	self export: true.
	^self cCode: 'multiPointerShutdown()' inSmalltalk:[true]! !
